function K2BExtendedCombo($) {
  this.control = null;
  this.Values = null;
  this.data = null;

  // Databinding for property Attribute
  this.SetAttribute = function (data) {
    ///UserCodeRegionStart:[SetAttribute] (do not remove this comment.)
    if (this.control != null) this.control[0].value = data;
    this.data = data;
    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  // Databinding for property Attribute
  this.GetAttribute = function () {
    ///UserCodeRegionStart:[GetAttribute] (do not remove this comment.)
    return this.data;

    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  this.SetValues = function (v) {
    this.Values = v;
    if (this.control != null) this.control[0].values = this.Values;
  };

  this.SetValue = function (v) {
    this.SetAttribute(v);

    if (uc.ControlValueChanged) {
      uc.ControlValueChanged();
    }
  };

  this.show = function (force) {
    var uc = this;
    if (this.control == null || this.control.length == 0) {
      // Only create control once
      this.control = $('<k2bt-enhancedcombo />');
      this.control[0].values = this.Values;
      this.control[0].value = this.data;
      this.control[0].includesearch = this.IncludeSearch;
      this.control[0].enableadditem = this.EnableAddItem;
      this.control[0].includeemptyitem = this.IncludeEmptyItem;
      this.control[0].enabled = this.Enabled;
      this.control[0].readonlyclass = this.Class.split(' ')
        .map(s => 'Readonly' + s)
        .join(' ');

      this.control[0].emptyitemtext = this.getTranslatedMessage(this.resolveValue(this.EmptyItemText, 'GX_EmptyItemText'));
      this.control[0].noresultsfoundtext = this.getTranslatedMessage(this.resolveValue(this.NoResultsFoundText, 'K2BT_NoItems'));
      this.control[0].searchfieldplaceholder = this.getTranslatedMessage(this.resolveValue(this.SearchFieldPlaceholder, 'K2BT_Search'));
      this.control[0].additemcaption = this.getTranslatedMessage(this.resolveValue(this.AddItemCaption, 'K2BT_EnhancedComboAddItemCaption'));

      this.control.on('change', function (event) {
        uc.SetAttribute(uc.control[0].value);

        uc.onchange();
        if (uc.ComboboxValueChanged) {
          uc.ComboboxValueChanged();
        }

        if (uc.ControlValueChanged) {
          uc.ControlValueChanged();
        }
      });

      this.control.on('newRecordClicked', function (event) {
        if (uc.CreateItem) {
          uc.CreateItem();
        }
      });

      this.control.on('input', function () {
        uc.SetAttribute(uc.control[0].value);
        uc.oninput();
      });

      this.control.on('focus', this.onfocus.closure(this));

      var container = $('#' + this.ContainerName);
      container.append(this.control);
    }
  };

  this.resolveValue = function (provided, defaultValue) {
    return provided == undefined || provided == '' || provided == null ? defaultValue : provided;
  };

  this.getTranslatedMessage = function (msg) {
    if (msg.indexOf('GX') == 0 || msg.indexOf('K2B') == 0) {
      var translated = gx.msg[msg];
      if (translated !== undefined) {
        return translated;
      }
    }
    return msg;
  };
}
